Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Properties/AssemblyInfo.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Properties/AssemblyInfo.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Properties/AssemblyInfo.cs	(revision 5539)
@@ -0,0 +1,29 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("Voip")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("Voip")]
+[assembly: AssemblyCopyright("Copyright ©  2016")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: ComVisible(false)]
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Voip.csproj	(revision 5539)
@@ -0,0 +1,164 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="CheckAPI" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <!--Check for API_Family-->
+  <PropertyGroup>
+      <PROJ_Target>UWP</PROJ_Target>
+  </PropertyGroup>
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-targets.targets" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">x86</Platform>
+    <ProjectGuid>{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9}</ProjectGuid>
+    <OutputType>AppContainerExe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>VoipUI</RootNamespace>
+    <AssemblyName>Voip</AssemblyName>
+    <DefaultLanguage>en-US</DefaultLanguage>
+    <MinimumVisualStudioVersion>14</MinimumVisualStudioVersion>
+    <EnableDotNetNativeCompatibleProfile>true</EnableDotNetNativeCompatibleProfile>
+    <FileAlignment>512</FileAlignment>
+    <ProjectTypeGuids>{A5A43C5B-DE2A-4C0C-9213-0A381AF9435A};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+    <PackageCertificateKeyFile>Voip_TemporaryKey.pfx</PackageCertificateKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|ARM'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\ARM\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>ARM</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|ARM'">
+    <OutputPath>bin\ARM\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>ARM</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+    <UseDotNetNativeToolchain>true</UseDotNetNativeToolchain>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+    <UseDotNetNativeToolchain>true</UseDotNetNativeToolchain>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE;NETFX_CORE;WINDOWS_UWP</DefineConstants>
+    <Optimize>true</Optimize>
+    <NoWarn>;2008</NoWarn>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <UseVSHostingProcess>false</UseVSHostingProcess>
+    <ErrorReport>prompt</ErrorReport>
+    <Prefer32Bit>true</Prefer32Bit>
+    <UseDotNetNativeToolchain>true</UseDotNetNativeToolchain>
+  </PropertyGroup>
+  <ItemGroup>
+    <!-- A reference to the entire .Net Framework and Windows SDK are automatically included -->
+    <Content Include="ApplicationInsights.config">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+    <None Include="project.json" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="App.xaml.cs">
+      <DependentUpon>App.xaml</DependentUpon>
+    </Compile>
+    <Compile Include="Helpers\AppServiceHelper.cs" />
+    <Compile Include="Helpers\EndpointHelper.cs" />
+    <Compile Include="Helpers\VoipCallHelper.cs" />
+    <Compile Include="MainPage.xaml.cs">
+      <DependentUpon>MainPage.xaml</DependentUpon>
+    </Compile>
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <AppxManifest Include="Package.appxmanifest">
+      <SubType>Designer</SubType>
+    </AppxManifest>
+    <None Include="Voip_TemporaryKey.pfx" />
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Properties\Default.rd.xml" />
+    <Content Include="Assets\LockScreenLogo.scale-200.png" />
+    <Content Include="Assets\SplashScreen.scale-200.png" />
+    <Content Include="Assets\Square150x150Logo.scale-200.png" />
+    <Content Include="Assets\Square44x44Logo.scale-200.png" />
+    <Content Include="Assets\Square44x44Logo.targetsize-24_altform-unplated.png" />
+    <Content Include="Assets\StoreLogo.png" />
+    <Content Include="Assets\Wide310x150Logo.scale-200.png" />
+  </ItemGroup>
+  <ItemGroup>
+    <ApplicationDefinition Include="App.xaml">
+      <Generator>MSBuild:Compile</Generator>
+      <SubType>Designer</SubType>
+    </ApplicationDefinition>
+    <Page Include="MainPage.xaml">
+      <Generator>MSBuild:Compile</Generator>
+      <SubType>Designer</SubType>
+    </Page>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\VoipBackEnd\VoipBackEnd.vcxproj">
+      <Project>{fc9cbb95-624c-4ce8-86a8-3ab5a415aa65}</Project>
+      <Name>VoipBackEnd</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\VoipHost\VoipHost.vcxproj">
+      <Project>{016d497f-0ee0-449e-89f5-bd63f7f9a8a6}</Project>
+      <Name>VoipHost</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\VoipTasks\VoipTasks.csproj">
+      <Project>{9fdf5e33-d15d-409f-876e-4e77727936b9}</Project>
+      <Name>VoipTasks</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <PropertyGroup Condition=" '$(VisualStudioVersion)' == '' or '$(VisualStudioVersion)' &lt; '14.0' ">
+    <VisualStudioVersion>14.0</VisualStudioVersion>
+  </PropertyGroup>
+  <Import Project="$(MSBuildExtensionsPath)\Microsoft\WindowsXaml\v$(VisualStudioVersion)\Microsoft.Windows.UI.Xaml.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/package.appxmanifest
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/package.appxmanifest	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/package.appxmanifest	(revision 5539)
@@ -0,0 +1,53 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Package xmlns="http://schemas.microsoft.com/appx/manifest/foundation/windows10" xmlns:mp="http://schemas.microsoft.com/appx/2014/phone/manifest" xmlns:uap="http://schemas.microsoft.com/appx/manifest/uap/windows10" IgnorableNamespaces="uap mp">
+  <Identity Name="43db1af2-7e7c-499d-8ca6-9f3695ed1ec9" Publisher="CN=Riza" Version="1.0.0.0" />
+  <mp:PhoneIdentity PhoneProductId="43db1af2-7e7c-499d-8ca6-9f3695ed1ec9" PhonePublisherId="00000000-0000-0000-0000-000000000000" />
+  <Properties>
+    <DisplayName>Voip</DisplayName>
+    <PublisherDisplayName>Riza</PublisherDisplayName>
+    <Logo>Assets\StoreLogo.png</Logo>
+  </Properties>
+  <Dependencies>
+    <TargetDeviceFamily Name="Windows.Universal" MinVersion="10.0.0.0" MaxVersionTested="10.0.0.0" />
+  </Dependencies>
+  <Resources>
+    <Resource Language="x-generate" />
+  </Resources>
+  <Applications>
+    <Application Id="App" Executable="$targetnametoken$.exe" EntryPoint="VoipUI.App">
+      <uap:VisualElements DisplayName="Voip" Square150x150Logo="Assets\Square150x150Logo.png" Square44x44Logo="Assets\Square44x44Logo.png" Description="Voip" BackgroundColor="transparent">
+        <uap:DefaultTile Wide310x150Logo="Assets\Wide310x150Logo.png">
+        </uap:DefaultTile>
+      </uap:VisualElements>
+      <Extensions>
+        <Extension Category="windows.backgroundTasks" EntryPoint="VoipTasks.CallRtcTask">
+          <BackgroundTasks ServerName="VoipHost">
+            <Task Type="systemEvent" />
+          </BackgroundTasks>
+        </Extension>
+        <uap:Extension Category="windows.appService" EntryPoint="VoipTasks.AppService">
+          <uap:AppService Name="VoipTasks.AppService" ServerName="VoipHost" />
+        </uap:Extension>
+        <uap:Extension Category="windows.voipCall">
+        </uap:Extension>
+      </Extensions>
+    </Application>
+  </Applications>
+  <Capabilities>
+    <Capability Name="internetClientServer" />
+    <Capability Name="privateNetworkClientServer" />
+    <uap:Capability Name="voipCall" />
+    <uap:Capability Name="phoneCall" />
+    <DeviceCapability Name="microphone" />
+    <DeviceCapability Name="webcam" />
+  </Capabilities>
+  <Extensions>
+    <Extension Category="windows.activatableClass.outOfProcessServer">
+      <OutOfProcessServer ServerName="VoipHost">
+        <Path>VoipHost.exe</Path>
+        <Instancing>singleInstance</Instancing>
+        <ActivatableClass ActivatableClassId="VoipHost.Dummy" />
+      </OutOfProcessServer>
+    </Extension>
+  </Extensions>
+</Package>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.cpp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.cpp	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.cpp	(revision 5539)
@@ -0,0 +1,18 @@
+/* 
+    Copyright (c) 2012 Microsoft Corporation.  All rights reserved.
+    Use of this sample source code is subject to the terms of the Microsoft license 
+    agreement under which you licensed this sample source code and is provided AS-IS.
+    If you did not accept the terms of the license agreement, you are not authorized 
+    to use this sample source code.  For the terms of the license, please see the 
+    license agreement between you and Microsoft.
+  
+*/
+#include "pch.h"
+#include "ApiLock.h"
+
+namespace VoipBackEnd
+{
+    // A mutex used to protect objects accessible from the API surface exposed by this DLL
+    std::recursive_mutex g_apiLock;
+}
+
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.h
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.h	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/ApiLock.h	(revision 5539)
@@ -0,0 +1,21 @@
+/* 
+    Copyright (c) 2012 Microsoft Corporation.  All rights reserved.
+    Use of this sample source code is subject to the terms of the Microsoft license 
+    agreement under which you licensed this sample source code and is provided AS-IS.
+    If you did not accept the terms of the license agreement, you are not authorized 
+    to use this sample source code.  For the terms of the license, please see the 
+    license agreement between you and Microsoft.
+  
+    To see all Code Samples for Windows Phone, visit http://go.microsoft.com/fwlink/?LinkID=219604 
+  
+*/
+#pragma once
+#include <mutex>
+
+
+namespace VoipBackEnd
+{
+    // A mutex used to protect objects accessible from the API surface exposed by this DLL
+    extern std::recursive_mutex g_apiLock;
+}
+
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.cpp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.cpp	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.cpp	(revision 5539)
@@ -0,0 +1,632 @@
+/* $Id$ */
+/*
+* Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "MyApp.h"
+#include <memory>
+#include <winerror.h>
+#include <pplawait.h>
+
+using namespace VoipBackEnd;
+using namespace Windows::Storage;
+
+const std::string CONFIG_NAME = "pjsua2.json";
+const int SIP_PORT  = 5060;
+const int LOG_LEVEL = 5;
+const std::string THIS_FILE = "MyApp.cpp";
+
+#define GenHresultFromITF(x) (MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, x))
+
+MyAppRT^ MyAppRT::singleton = nullptr;
+
+#define DEFAULT_DESTRUCTOR() \
+    delete inPtr;
+
+#define CHECK_EXCEPTION(expr) \
+	do { \
+	    try { \
+		(expr); 	\
+	    } catch (pj::Error e) { \
+		Platform::Exception^ exp = ref new Platform::COMException( \
+		    GenHresultFromITF(e.status)); \
+	    } \
+	} while (0)
+
+///////////////////////////////////////////////////////////////////////////////
+std::string make_string(const std::wstring& wstring)
+{
+    auto wideData = wstring.c_str();
+    int bufferSize = WideCharToMultiByte(CP_UTF8, 0, wideData, 
+					 -1, nullptr, 0, NULL, NULL);
+
+    std::unique_ptr<char[]> utf8;
+    utf8.reset(new char[bufferSize]);    
+
+    if (WideCharToMultiByte(CP_UTF8, 0, wideData, -1,
+	utf8.get(), bufferSize, NULL, NULL) == 0) 
+    {	
+	return std::string();
+    }
+
+    return std::string(utf8.get());    
+}
+
+std::wstring make_wstring(const std::string& string)
+{
+    auto utf8Data = string.c_str();
+    int bufferSize = MultiByteToWideChar(CP_UTF8, 0, utf8Data, -1, nullptr, 0);
+
+    std::unique_ptr<wchar_t[]> wide;
+    wide.reset(new wchar_t[bufferSize]);
+
+    if (MultiByteToWideChar(CP_UTF8, 0, utf8Data, -1,
+	wide.get(), bufferSize) == 0)
+    {	
+	return std::wstring();
+    }	    
+
+    return std::wstring(wide.get());;
+}
+
+std::string to_std_str(Platform::String ^in_str)
+{
+    std::wstring wsstr(in_str->Data());
+    return make_string(wsstr);
+}
+
+Platform::String^ to_platform_str(const std::string& in_str)
+{
+    std::wstring wsstr = make_wstring(in_str);
+    return ref new Platform::String(wsstr.c_str(), wsstr.length());
+}
+
+///////////////////////////////////////////////////////////////////////////////
+void ImpLogWriter::write(const pj::LogEntry &entry)
+{
+    std::wstring msg = make_wstring(entry.msg) + L"\r\n";
+
+    ::OutputDebugString(msg.c_str());    
+}
+///////////////////////////////////////////////////////////////////////////////
+OnRegStateParamRT::OnRegStateParamRT(const pj::OnRegStateParam& param)
+
+{
+    inPtr = new pj::OnRegStateParam(param);
+}
+
+OnRegStateParamRT::OnRegStateParamRT()
+{
+    inPtr = new pj::OnRegStateParam();
+}
+
+OnRegStateParamRT::~OnRegStateParamRT()
+{
+    DEFAULT_DESTRUCTOR();
+}
+
+pj_status_t OnRegStateParamRT::status::get()
+{
+    return inPtr->status;
+}
+
+unsigned OnRegStateParamRT::code::get()
+{
+    return static_cast<unsigned>(inPtr->code);
+}
+
+Platform::String^ OnRegStateParamRT::reason::get()
+{
+    return to_platform_str(inPtr->reason);
+}
+
+int OnRegStateParamRT::expiration::get()
+{
+    return inPtr->expiration;
+}
+///////////////////////////////////////////////////////////////////////////////
+void ImpAccount::setCallback(IntAccount^ callback)
+{
+    cb = callback;
+}
+
+void ImpAccount::onIncomingCall(pj::OnIncomingCallParam& prm)
+{
+    if (cb) {
+	if (MyAppRT::Instance->handleIncomingCall(prm.callId)) {
+	    CallInfoRT^ info = MyAppRT::Instance->getCallInfo();
+	    if (info != nullptr)
+		cb->onIncomingCall(info);
+	}
+    }
+}
+
+
+void ImpAccount::onRegState(pj::OnRegStateParam& prm)
+{
+    if (cb)
+	cb->onRegState(ref new OnRegStateParamRT(prm));
+}
+
+///////////////////////////////////////////////////////////////////////////////
+CallInfoRT::CallInfoRT(const pj::CallInfo& info)
+{
+    inPtr = new pj::CallInfo(info);
+}
+
+Platform::String^ CallInfoRT::localUri::get()
+{
+    return to_platform_str(inPtr->localUri);
+}
+
+Platform::String^ CallInfoRT::localContact::get()
+{
+    return to_platform_str(inPtr->localContact);
+}
+
+Platform::String^ CallInfoRT::remoteUri::get()
+{
+    return to_platform_str(inPtr->remoteUri);
+}
+
+Platform::String^ CallInfoRT::remoteContact::get()
+{
+    return to_platform_str(inPtr->remoteContact);
+}
+
+INV_STATE CallInfoRT::state::get()
+{
+    return static_cast<INV_STATE>(inPtr->state);
+}
+
+CallInfoRT::~CallInfoRT()
+{
+    DEFAULT_DESTRUCTOR();
+}
+///////////////////////////////////////////////////////////////////////////////
+CallOpParamRT::CallOpParamRT()
+{
+    inPtr = new pj::CallOpParam(true);
+}
+
+unsigned CallOpParamRT::statusCode::get() 
+{
+    return static_cast<unsigned>(inPtr->statusCode);
+}
+
+void CallOpParamRT::statusCode::set(unsigned val) 
+{
+    inPtr->statusCode = static_cast<pjsip_status_code>(val);
+}
+
+Platform::String^ CallOpParamRT::reason::get() 
+{
+    return to_platform_str(inPtr->reason);
+}
+
+void CallOpParamRT::reason::set(Platform::String^ val) 
+{
+    inPtr->reason = to_std_str(val);
+}
+
+pj::CallOpParam* CallOpParamRT::getPtr()
+{
+    return inPtr;
+}
+
+CallOpParamRT::~CallOpParamRT()
+{
+    DEFAULT_DESTRUCTOR();
+}
+
+///////////////////////////////////////////////////////////////////////////////
+ImpCall::ImpCall(pj::Account& account, int call_id) : pj::Call(account,call_id)
+{};
+
+void ImpCall::setCallback(IntCall^ callback)
+{
+    cb = callback;
+}
+
+void ImpCall::onCallState(pj::OnCallStateParam& prm)
+{
+    if (cb) {
+	pj::CallInfo info = getInfo();	
+	cb->onCallState(ref new CallInfoRT(info));
+    }
+};
+
+void ImpCall::onCallMediaState(pj::OnCallMediaStateParam& prm)
+{
+    pj::CallInfo info;    
+    try {
+	info = getInfo();
+    } catch (pj::Error& e) {
+	MyAppRT::Instance->writeLog(2, to_platform_str(e.info()));
+	return;
+    }
+
+    for (unsigned i = 0; i < info.media.size(); i++) {
+	pj::CallMediaInfo med_info = info.media[i];
+	if ((med_info.type == PJMEDIA_TYPE_AUDIO) &&
+	    ((med_info.status == PJSUA_CALL_MEDIA_ACTIVE) ||
+	    (med_info.status == PJSUA_CALL_MEDIA_REMOTE_HOLD))
+	    )
+	{
+	    pj::Media* m = getMedia(i);
+	    pj::AudioMedia *am = pj::AudioMedia::typecastFromMedia(m);
+	    pj::AudDevManager& aud_mgr = 
+		pj::Endpoint::instance().audDevManager();
+
+	    try {
+		aud_mgr.getCaptureDevMedia().startTransmit(*am);
+		am->startTransmit(aud_mgr.getPlaybackDevMedia());	
+
+	    } catch (pj::Error& e) {
+		MyAppRT::Instance->writeLog(2, to_platform_str(e.info()));
+		continue;
+	    }	
+	}
+    }
+};
+///////////////////////////////////////////////////////////////////////////////
+
+AccountInfo::AccountInfo(pj::AccountConfig* accConfig) : cfg(accConfig)
+{}
+
+Platform::String^ AccountInfo::id::get() {
+    return  to_platform_str(cfg->idUri);
+}
+
+Platform::String^ AccountInfo::registrar::get() {
+    return to_platform_str(cfg->regConfig.registrarUri);
+}
+
+Platform::String^ AccountInfo::proxy::get() {
+    if (!cfg->sipConfig.proxies.empty()) {
+	return to_platform_str(cfg->sipConfig.proxies[0]);
+    } else {
+	return ref new Platform::String(L"");
+    }
+}
+
+Platform::String^ AccountInfo::username::get() {
+    if (!cfg->sipConfig.authCreds.empty()) {
+	pj::AuthCredInfo& info = cfg->sipConfig.authCreds[0];
+
+	return to_platform_str(info.username);
+    } else {
+	return ref new Platform::String(L"");
+    }
+}
+
+Platform::String^ AccountInfo::password::get() {
+    if (!cfg->sipConfig.authCreds.empty()) {
+	pj::AuthCredInfo& info = cfg->sipConfig.authCreds[0];
+
+	return to_platform_str(info.data);
+    } else {
+	return ref new Platform::String(L"");
+    }
+}
+
+///////////////////////////////////////////////////////////////////////////////
+MyAppRT::MyAppRT()
+{        
+    logWriter = new ImpLogWriter();
+
+    StorageFolder^ localFolder = ApplicationData::Current->LocalFolder;
+
+    appDir = to_std_str(localFolder->Path);
+}
+
+MyAppRT::~MyAppRT()
+{        
+    delete logWriter;
+    if (account)
+	delete account;
+
+    if (epConfig)
+	delete epConfig;
+
+    if (accConfig)
+	delete accConfig;
+
+    if (sipTpConfig)
+	delete sipTpConfig;
+}
+
+void MyAppRT::loadConfig()
+{
+    pj::JsonDocument* json = new pj::JsonDocument();
+
+    std::string configPath = appDir + "/" + CONFIG_NAME;
+
+    try {
+	/* Load file */
+	json->loadFile(configPath);
+	pj::ContainerNode root = json->getRootContainer();
+
+	/* Read endpoint config */
+	epConfig->readObject(root);
+
+	/* Read transport config */
+	pj::ContainerNode tp_node = root.readContainer("SipTransport");
+	sipTpConfig->readObject(tp_node);
+
+	/* Read account configs */
+	pj::ContainerNode acc_node = root.readContainer("Account");
+	accConfig->readObject(acc_node);
+    } catch (pj::Error) {
+	ep.utilLogWrite(2, "loadConfig", "Failed loading config");
+
+	sipTpConfig->port = SIP_PORT;
+    }
+
+    delete json;
+}
+
+void MyAppRT::saveConfig()
+{
+    pj::JsonDocument* json = new pj::JsonDocument();
+
+    std::string configPath = appDir + "/" + CONFIG_NAME;
+
+    try {
+	/* Write endpoint config */
+	json->writeObject(*epConfig);	
+
+	/* Write transport config */
+	pj::ContainerNode tp_node = json->writeNewContainer("SipTransport");
+	sipTpConfig->writeObject(tp_node);
+
+	/* Write account configs */	
+	pj::ContainerNode acc_node = json->writeNewContainer("Account");
+	accConfig->writeObject(acc_node);
+
+	/* Save file */
+	json->saveFile(configPath);
+    } catch (pj::Error) {
+	ep.utilLogWrite(2, "saveConfig", "Failed saving config");
+
+	sipTpConfig->port = SIP_PORT;
+    }
+
+    delete json;
+}
+
+MyAppRT^ MyAppRT::Instance::get()
+{
+    if (MyAppRT::singleton == nullptr)
+    {
+	if (MyAppRT::singleton == nullptr)
+	{
+	    MyAppRT::singleton = ref new MyAppRT();
+	}
+    }
+
+    return MyAppRT::singleton;
+}
+
+void MyAppRT::init(IntAccount^ iAcc, IntCall^ iCall)
+{    
+    /* Create endpoint */
+    try {
+	ep.libCreate();
+    } catch (pj::Error e) {
+	return;
+    }
+
+    intAcc = iAcc;
+    intCall = iCall;
+
+    epConfig = new pj::EpConfig;
+    accConfig = new pj::AccountConfig;
+    sipTpConfig = new pj::TransportConfig;
+
+    /* Load config */    
+    loadConfig();
+
+    /* Override log level setting */
+    epConfig->logConfig.level = LOG_LEVEL;
+    epConfig->logConfig.consoleLevel = LOG_LEVEL;
+
+    /* Set log config. */
+    pj::LogConfig *log_cfg = &epConfig->logConfig;
+    log_cfg->writer = logWriter;
+    log_cfg->decor = log_cfg->decor &
+	~(::pj_log_decoration::PJ_LOG_HAS_CR |
+	  ::pj_log_decoration::PJ_LOG_HAS_NEWLINE);
+
+    /* Set ua config. */
+    pj::UaConfig* ua_cfg = &epConfig->uaConfig;
+    ua_cfg->userAgent = "Pjsua2 WinRT " + ep.libVersion().full;
+    ua_cfg->mainThreadOnly = false;
+
+    /* Init endpoint */
+    try
+    {
+	ep.libInit(*epConfig);
+    } catch (pj::Error& e)
+    {
+	ep.utilLogWrite(2,THIS_FILE,e.info());
+	return;
+    }
+
+    /* Create transports. */
+
+    try {
+	sipTpConfig->port = 5060;
+	ep.transportCreate(::pjsip_transport_type_e::PJSIP_TRANSPORT_TCP,
+			   *sipTpConfig);
+    } catch (pj::Error& e) {
+	ep.utilLogWrite(2,THIS_FILE,e.info());	
+    }
+
+    try {
+	ep.transportCreate(::pjsip_transport_type_e::PJSIP_TRANSPORT_UDP,
+			   *sipTpConfig);
+    } catch (pj::Error& e) {
+	ep.utilLogWrite(2,THIS_FILE,e.info());
+    }    
+
+    /* Create accounts. */    
+    account = new ImpAccount();
+    if (accConfig->idUri.length() == 0) {
+	accConfig->idUri = "sip:localhost";	
+    } else {
+	ua_cfg->stunServer.push_back("stun.pjsip.org");	
+    }
+    //accConfig->natConfig.iceEnabled = true;
+    account->create(*accConfig);
+    account->setCallback(iAcc);
+
+    /* Start. */
+    try {
+	ep.libStart();
+    } catch (pj::Error& e) {
+	ep.utilLogWrite(2,THIS_FILE,e.info());
+	return;
+    }
+}
+
+void MyAppRT::deInit()
+{
+    saveConfig();
+
+    try {
+	ep.libDestroy();
+    } catch (pj::Error) {}
+
+}
+
+void MyAppRT::writeLog(int level, Platform::String^ message)
+{
+    ep.utilLogWrite(level, "MyAppRT", to_std_str(message));
+}
+
+void MyAppRT::hangupCall()
+{
+    if (activeCall) {
+	if (!isThreadRegistered())
+	{
+	    registerThread("hangupCall");
+	}
+	
+	delete activeCall;
+	activeCall = NULL;
+    }
+};
+
+void MyAppRT::answerCall(CallOpParamRT^ prm)
+{
+    if (!isThreadRegistered())
+    {
+	registerThread("answerCall");
+    }
+    CHECK_EXCEPTION(activeCall->answer(*prm->getPtr()));
+};
+
+void MyAppRT::makeCall(Platform::String^ dst_uri)
+{
+    if (!isThreadRegistered())
+    {
+	registerThread("makeCall");
+    }
+    CallOpParamRT^ param = ref new CallOpParamRT;
+    activeCall = new ImpCall(*account, -1);
+    activeCall->setCallback(intCall);
+
+    CHECK_EXCEPTION(activeCall->makeCall(to_std_str(dst_uri),*param->getPtr()));
+};
+
+CallInfoRT^ MyAppRT::getCallInfo()
+{
+    if (activeCall) {
+	pj::CallInfo info = activeCall->getInfo();
+	return ref new CallInfoRT(info);
+    }
+
+    return nullptr;
+}
+
+pj_bool_t MyAppRT::handleIncomingCall(int callId)
+{    
+    if (activeCall) {
+	return PJ_FALSE;
+    }
+
+    activeCall = new ImpCall(*account, callId);
+    activeCall->setCallback(intCall);
+
+    return PJ_TRUE;
+}
+
+void MyAppRT::registerThread(Platform::String^ name)
+{
+    CHECK_EXCEPTION(ep.libRegisterThread(to_std_str(name)));
+}
+
+bool MyAppRT::isThreadRegistered()
+{
+    // Some threads are registered using PJLIB API, ep.libIsThreadRegistered() will return false on those threads.
+    //return ep.libIsThreadRegistered();
+    return pj_thread_is_registered() != PJ_FALSE;
+}
+
+AccountInfo^ MyAppRT::getAccountInfo()
+
+{    
+    return ref new AccountInfo(accConfig);
+}
+
+void MyAppRT::modifyAccount(Platform::String^ id, 
+			    Platform::String^ registrar,
+			    Platform::String^ proxy, 			    
+			    Platform::String^ username,
+			    Platform::String^ password)
+{    
+    if (id->IsEmpty()) {
+	accConfig->idUri = "sip:localhost";
+	accConfig->regConfig.registrarUri = "";
+	accConfig->sipConfig.authCreds.clear();
+	accConfig->sipConfig.proxies.clear();
+    } else {
+	pj::AuthCredInfo info = pj::AuthCredInfo("Digest", "*", 
+						 to_std_str(username), 0, 
+						 to_std_str(password));
+
+	accConfig->idUri = to_std_str(id);
+	accConfig->regConfig.registrarUri = to_std_str(registrar);
+
+	accConfig->sipConfig.authCreds.clear();    
+	accConfig->sipConfig.authCreds.push_back(info);
+
+	accConfig->sipConfig.proxies.clear();
+	accConfig->sipConfig.proxies.push_back(to_std_str(proxy));
+    }
+
+    if (!isThreadRegistered())
+    {
+	registerThread("registerAccount");
+    }
+
+    account->modify(*accConfig);
+
+    /* Save config. */
+    saveConfig();
+}
